***************************************************

*

* PROGRAM TO COMBINE ULTIMATE DRIVER & BIOS.SYS

* 07/08/84	20:30

* 04/23/90	For Version 6.0 -- WL

*

EXIT	EQU	0

CONOUT	EQU	2

BDOS	EQU	5

CONSTR	EQU	9

OPEN	EQU	15

CLOSE	EQU	16

SREAD	EQU	20

SWRITE	EQU	21

SETDMA	EQU	26

RREAD	EQU	33

RWRITE	EQU	34

SETRRN	EQU	36

FCB1	EQU	5CH

DFCB	EQU	5CH+16

FCB1CR	EQU	5CH+32

FCB1RRN EQU	5CH+33

LF	EQU	10

CR	EQU	13

BELL	EQU	7

ELF	EQU	10+80H

ESP	EQU	' '+80H

*

	ORG	0100H

*

* GET FILE NAMES FROM COMMAND LINE

	LXI	SP,STACK

	LXI	D,DFCB

	LXI	H,FCB2	; MOVE THE 2ND FCB

	MVI	C,16

FCBL	LDAX	D

	INX	D

	MOV	M,A

	INX	H

	DCR	C

	JNZ	FCBL

	LXI	H,0	; ZERO CURRENT RECORD #

	SHLD	FCB1CR

	SHLD	FCB1CR+2

	SHLD	FCB2CR

	SHLD	FCB2CR+2

	CALL	TYPTX

	DB	'Program to add Ultimate printer '

	DB	'driver to BIOS.SYS',CR,LF

	DB	'V1.3, Copyright 1990, Lindley Systems',CR,LF

	DB	ELF

* SETUP THE BIOS FILE

	LDA	FCB1+1	; Input file name present?

	CPI	' '

	JZ	ERR1

	CALL	TYPTX

	DB	'BIOS file ',ESP

	LXI	H,FCB1

	CALL	SHOWFN

	CALL	TYPTX

	DB	CR,ELF

	LXI	D,FCB1

	MVI	A,OPEN

	CALL	BDOSF

	INR	A

	JZ	ERR3

	XRA	A

	STA	FCB1+12

	STA	FCB1+32

* SETUP THE OUTPUT FILE

	LDA	FCB2+1	; Output file name present?

	CPI	' '

	JZ	ERR2

	CALL	TYPTX

	DB	'Driver file ',ESP

	LXI	H,FCB2

	CALL	SHOWFN

	CALL	TYPTX

	DB	CR,ELF

	LXI	D,FCB2

	MVI	A,OPEN

	CALL	BDOSF

	INR	A

	JZ	ERR4

	XRA	A

	STA	FCB2+12

	STA	FCB2+32

	LHLD	BIOSORG

	SHLD	POINTER

* READ BIOS.SYS INTO WORK AREA

READ1:	LHLD	POINTER

	MOV	D,H

	MOV	E,L

	LXI	B,128

	DAD	B

	SHLD	POINTER

	MVI	A,SETDMA

	CALL	BDOSF

	LXI	D,FCB1

	MVI	A,SREAD

	CALL	BDOSF

	ORA	A

	JZ	READ1

* CLOSE FILE

	LXI	D,FCB1

	MVI	A,CLOSE

	CALL	BDOSF

* FIND PALCE TO PUT PATCH

	LHLD	POINTER

	LXI	B,-128

	DAD	B

	MOV	A,H

	ADI	02FH

	ANI	0F0H	; NEAREST 2000H

	SHLD	POINTER

	SHLD	PTCHORG ; PATCH ORIGIN

	INR	H

	SHLD	ORG3	; PATCH DATA START

*

* GET CP/M VERSION

	LHLD	ORG1

	LXI	D,033H

	DAD	D	; VERSION LOCATION

	MOV	A,M

	ORA	A		; 0 => VERS .02

	JNZ	TRY3

	LHLD	ORG1

	PUSH	H

	INX	H

	MOV	A,M

	INX	H

	MOV	H,M

	MOV	L,A	; COLD BOOT STACK

	INX	H

	INX	H

	POP	D

	DAD	D

	SHLD	STACK2

	MVI	A,'2'

	LXI	B,4AH	; 04AH OFFSET

	JMP	VEROK

TRY3:	ADI	'0'

	CPI	'3'		; 3 => VERS .03

	JNZ	TRY4

	LXI	B,47H	; 047H OFFSET

	JMP	VEROK

TRY4:	CPI	'4'		; 4 => VERS .04

	JNZ	VERNG

	LXI	B,4BH	; 04BH OFFSET

	JMP	VEROK

VERNG:	CALL	TYPTX

	DB	'This version of CP/M is not supported.'

	DB	CR,ELF

	JMP	BYE

VEROK:	STA	VERS	; SHOW VERSION

	LHLD	ORG1

	DAD	B	; ADDRESS OF ACTUAL BIOS

	SHLD	ABLADD	;   LENGTH

	MOV	A,M

	INX	H

	MOV	H,M

	MOV	L,A

	LXI	D,0FFFH

	DAD	D

	MVI	L,0

	MOV	A,H

	ADI	10H

	ANI	70H	; ROUND TO NEAREST 1000H

	MOV	H,A

	LXI	D,WORK

	DAD	D

	SHLD	ORG3

	SHLD	POINTER

	CALL	TYPTX

	DB	'CP/M Version 2.2.0'

VERS:	DB	'0',CR,ELF

*

* READ IN PATCH

READ2:	LHLD	POINTER

	MOV	D,H

	MOV	E,L

	LXI	B,128

	DAD	B

	SHLD	POINTER

	MVI	A,SETDMA

	CALL	BDOSF

	LXI	D,FCB2

	MVI	A,SREAD

	CALL	BDOSF

	ORA	A

	JZ	READ2

* CLOSE FILE

	LXI	D,FCB2

	MVI	A,CLOSE

	CALL	BDOSF

* SAVE END OF DATA LOCATION

	LHLD	POINTER

	LXI	B,0FFFH

	DAD	B

	MVI	L,0

	MOV	A,H

	ADI	010H

	ANI	0F0H

	MOV	H,A

	SHLD	ORG5	; START OF SCRATCH AREA

* MOVE BIOS BIT MAP TO END AREA

	LHLD	BIOSORG

	INX	H

	MOV	A,M

	INX	H

	MOV	H,M

	MOV	L,A

	SHLD	LEN1

	PUSH	H	; BIT MAP OFFSET

	LXI	B,7

	DAD	B

	MVI	B,3

	CALL	RSHIFT	; BIOS BIT MAP LENGTH

	SHLD	LEN2

	LHLD	ORG1	; START OF BIOS

	POP	B	; OFFSET TO BIT MAP

	DAD	B	; ORIGIN OF BIT MAP

	PUSH	H

	SHLD	ORG2

	LHLD	LEN2	; BIT MAP LENGTH

	PUSH	H

	LHLD	ORG5

	XCHG

	POP	B

	POP	H

* SET B,C = BYTE COUNT

*     D,E -> DESTINATION

*     H,L -> SOURCE

	CALL	MOVE

	XCHG

	SHLD	ORG6	; PATCH BIT MAP START

* FILL IN EMPTY END SPACE WITH ZEROS

	LHLD	LEN1

	MOV	A,H

	CMA

	MOV	B,A

	MOV	A,L

	CMA

	MOV	C,A

	INX	B	; - OFFSET

	LHLD	ABLADD

	MOV	A,M

	INX	H

	MOV	H,M

	MOV	L,A	; ACTUAL BIOS LENGTH

	SHLD	LEN1A

	DAD	B

	MOV	B,H

	MOV	C,L	; NUMBER OF ZEROS

	LHLD	ORG2	; START OF ZERO FILL

	CALL	ZFILL

ZF2:	SHLD	ORG2	; BYTE AFTER FILL

	LHLD	LEN1A	; FIND MOD 8 LENGTH

	LXI	B,7

	DAD	B

	MVI	B,3

	CALL	RSHIFT

	SHLD	LEN2A	; FULL BIOS MAP LENGTH

	MVI	B,3

	CALL	LSHIFT

	SHLD	LEN1A	; FULL BIOS LENGTH

	XCHG

	LHLD	ORG1

	DAD	D

	SHLD	ORG3A	; PATCH ORIGIN

* ZERO FILL EMPTY BIOS BIT MAP AREA

	LHLD	LEN2	; ORIGINAL BIT MAP LENGTH

	MOV	A,H

	CMA

	MOV	B,A

	MOV	A,L

	CMA

	MOV	C,A

	INX	B	; NEGATED LENGTH

	LHLD	LEN2A	; NEW BIT MAP LENGTH

	DAD	B	; NUMBER OF ZEROS TO ADD

	MOV	B,H

	MOV	C,L

	LHLD	ORG6

	CALL	ZFILL

	SHLD	ORG6	; MARK PATCH BIT MAP START

* ADD OFFSET TO ALL ADDRESSES

	LHLD	ORG3

	INX	H	; GET PATCH DATA LENGTH

	MOV	A,M

	INX	H

	MOV	H,M

	MOV	L,A

	SHLD	LEN3	; SAVE IT

	MOV	B,H

	MOV	C,L

	LHLD	ORG3

	INR	H	; + 100H

	SHLD	ORG3	; UPDATE TO DATA START

	DAD	B

	SHLD	ORG4	; BIT MAP START

	SHLD	POINTER

	INX	B	; DATA COUNT + 1

	MVI	E,1

	LHLD	ORG3	; PATCH ORIGIN

ALOOP:	DCX	B

	MOV	A,B

	ORA	C

	JZ	RELXIT

	DCR	E	; MORE BITS LEFT ?

	JNZ	BITSOK

	PUSH	H

	LHLD	POINTER

	MOV	D,M

	INX	H

	SHLD	POINTER

	POP	H

	MVI	E,8	; EIGHT BITS

BITSOK: MOV	A,D

	RAL

	MOV	D,A

	JNC	BYTEOK

	PUSH	D	; BITS & COUNT

	PUSH	B	; BYTE COUNT

	PUSH	H	; BYTE POINTER

	LHLD	LEN1A	; GET THE OFFSET

	XCHG

	POP	H

	DCX	H

	PUSH	H

	MOV	A,M	; GET THE ADDRESS

	INX	H

	MOV	H,M

	MOV	L,A

	DAD	D	; ADD THE OFFSET

	XCHG

	POP	H

	MOV	M,E

	INX	H

	MOV	M,D

	POP	B

	POP	D

BYTEOK: INX	H	; BYTE POINTER

	JMP	ALOOP

* MOVE PATCH BIT MAP TO END OF BIOS BIT MAP

RELXIT: LHLD	LEN3

	PUSH	H	; PATCH CODE LENGTH

	LXI	B,7

	DAD	B

	MVI	B,3

	CALL	RSHIFT	; PATCH BIT MAP LENGTH

	SHLD	LEN4

	MVI	B,3

	CALL	LSHIFT

	SHLD	LEN3A	; PATCH DATA + MOD 8

	LHLD	ORG3

	POP	B	; OFFSET TO BIT MAP

	DAD	B	; PATCH BIT MAP ORIGIN

	PUSH	H

	LHLD	ORG6	; DESTINATION

	XCHG

	LHLD	LEN4

	MOV	B,H

	MOV	C,L

	POP	H

	CALL	MOVE

* MOVE PATCH CODE TO END OF BIOS

	LHLD	LEN3A	; PATCH CODE LENGTH

	MOV	C,L

	MOV	B,H

	LHLD	ORG3A	; END OF BIOS

	XCHG

	LHLD	ORG3

	CALL	MOVE

	XCHG

	SHLD	ORG2A

* MOVE COMBINED BIT MAP TO END OF COMBINED CODE.

	LHLD	LEN2A

	XCHG

	LHLD	LEN4

	DAD	D

	MOV	B,H

	MOV	C,L

	SHLD	LEN5

	LHLD	ORG2A

	XCHG

	LHLD	ORG5

	CALL	MOVE

* FIND NUMBER OF DISK WRITES NEEDED

	XCHG

	LXI	D,07FH

	DAD	D

	MVI	B,7

	CALL	RSHIFT

	MOV	A,L

	SUI	WORK/128

	INR	A

	STA	ENDATA

* FIX UP BIT MAP POINTER AND JUMPS

	LHLD	LEN1A	; New BIOS length

	XCHG

	LHLD	LEN3A	; Patch length

	DAD	D

	SHLD	WORK+1	; New bitmap origin

	XCHG		;   is total length

	LHLD	ABLADD	; ACTUAL BIOS LENGTH

	INX	H	;   LOCATION

	MOV	M,D

	DCX	H

	MOV	M,E	; for MOVCPM length

	PUSH	H

	LHLD	STACK2	; VERS .02?

	MOV	A,H

	ORA	L

	JZ	NOT2

* VER 2.2.02 PREVENT COLD BOOT STACK OVERWRITE

	MVI	M,0FFH

	INX	H

	MOV	M,D

	LXI	H,WORK+1C8H

	MVI	M,0FFH

	INX	H

	MOV	M,D

	POP	H

	JMP	CON2

NOT2:	POP	H

	MOV	A,E

	ORA	A

	JZ	NOINCR

	INR	D

NOINCR: DCX	H	; NUMBER OF PAGES

	MOV	M,D

CON2:	MOV	A,D

* REQUIRED DRIVER HEADER LAYOUT

*	ORG	ADDRESS OF PARAMETERS

*	ORG+2	RESTORE ADDRESS LOCATION

*	ORG+4	JUMP TO SIGNON

*	ORG+7	JUMP TO STATUS ENTRY

*	ORG+10	START OF DRIVER CODE

	LHLD	ORG3A	; DRIVER START

	LXI	B,-BCOFF+7 ; OFFSET TO JMP LPTOS

	DAD	B	; IN PATCH

	MOV	B,H

	MOV	C,L

	LHLD	BCOFF+02EH ; GET LISTST ADDRESS

	LXI	D,BCOFF+00CH ; OFFSET TO 3RD TABLE ITEM

	DAD	D

	MOV	M,C	; INSERT JMP LPTOS ADDR

	INX	H

	MOV	M,B

	INX	B

	INX	B

	INX	B	; DRIVER CODE START ADDR

	LHLD	BCOFF+010H ; OFFSET TO JMP LIST

	DAD	D	; OFFSET TO 3RD TABLE ENTRY

	MOV	M,C	; INSERT LPTOUT ADDRESS

	INX	H

	MOV	M,B

* SET CALL TO SIGNON MESSAGE AND SAVE ADDRESS TO RESTORE

	LHLD	BCOFF+00DH ; JMP CONOUT ADDR

	LXI	D,BCOFF+4

	DAD	D	; CALL INDXIT LOCATION

	PUSH	H

	MOV	C,M

	INX	H

	MOV	B,M	; GOT CALL ADDRESS FIELD

	LHLD	ORG3A

	INX	H

	INX	H

	MOV	M,C

	INX	H

	MOV	M,B	; STORE ADDRESS TO RESTORE

	LXI	D,-BCOFF+1 ; JMP SIGNON OFFSET

	DAD	D

	XCHG

	POP	H

	MOV	M,E	; INSERT JMP SIGNON ADDR

	INX	H

	MOV	M,D

* MOVE BIOS.SYS BACK TO ITS FILE

BACK:	LXI	D,FCB1

	MVI	A,OPEN

	CALL	BDOSF

	INR	A

	JZ	ERR4

	XRA	A

	STA	FCB1+12

	STA	FCB1+32

	LXI	H,WORK

	SHLD	POINTER

WRIT1:	LHLD	POINTER

	MOV	D,H

	MOV	E,L

	LXI	B,128

	DAD	B

	SHLD	POINTER

	LXI	H,ENDATA

	DCR	M

	JZ	XIT

	MVI	A,SETDMA

	CALL	BDOSF

	LXI	D,FCB1

	MVI	A,SWRITE

	CALL	BDOSF

	ORA	A

	JNZ	ERR6

	JMP	WRIT1

XIT	LXI	D,FCB1

	MVI	A,CLOSE

	CALL	BDOSF

BYE:	CALL	TYPTX

	DB	'ULTBIOS action completed',CR,LF

	DB	'Ready for "MOVCPMxx *',ESP

	LXI	H,FCB1		; Show BIOS file again

	CALL	SHOWFN

	CALL	TYPTX

	DB	'" or "UPCBIOS..."',CR,ELF

	JMP	0

* B IS SHIFT COUNT

* H,L IS VALUE TO SHIFT

LSHIFT: DAD	H

	DCR	B

	JNZ	LSHIFT

	RET

*

RSHIFT: MOV	A,H

	ORA	A

	RAR

	MOV	H,A

	MOV	A,L

	RAR

	MOV	L,A

	DCR	B

	JNZ	RSHIFT

	RET

*

* H,L -> SOURCE

* D,E -> DESTINATION

* B,C IS BYTE COUNT

MOVE:	MOV	A,M

	STAX	D

	INX	H

	INX	D

	DCX	B

	MOV	A,B

	ORA	C

	JNZ	MOVE

	RET

*

* PUT INLINE TEXT ON CONSOLE

TYPTX	XTHL

W	MOV	A,M

	ANI	177Q

	CALL	COUT

	CMP	M

	INX	H

	JZ	W

	XTHL

	RET

*

* SHOW THE FILE NAME, (H,L)->FCB

SHOWFN	MOV	A,M	; GET DRIVE

	ANI	0FH

	JZ	SHOW1

	ORI	40H

	CALL	COUT

	MVI	A,':'

	CALL	COUT

SHOW1	INX	H

	MVI	D,8

	CALL	SHOWN

	MVI	A,'.'

	CALL	COUT

	MVI	D,3

SHOWN	MOV	A,M	; SHOW N CHAR OF NAME

	ANI	7FH

	CPI	'!'

	JC	SHOWN1

	CALL	COUT

SHOWN1	INX	H

	DCR	D

	JNZ	SHOWN

	RET

*

* OUTPUT CHARACTER IN A TO CONSOLE

COUT:	PUSH PSW ! PUSH B ! PUSH D ! PUSH H

	ANI	7FH

	MOV	E,A

	MVI	A,CONOUT

	CALL	BDOSF

	POP H ! POP D ! POP B ! POP PSW

	RET

*

* ZERO OUT TAIL OF FCB

ZEROFCB LXI	D,0CH

	DAD	D

	XRA	A	; ZERO

	MVI	D,24

Z1	MOV	M,A

	INX	H

	DCR	D

	JNZ	Z1

	RET

** BDOS FUNCTION CALL - USES REG A

BDOSF	PUSH H ! PUSH D ! PUSH B

	MOV	C,A

	CALL BDOS

	POP B  ! POP D	! POP H

	RET

* ZERO FILL ROUTINE

ZFILL:	MVI	D,0	; USES D

ZF1:	MOV	A,B	; COUNT IN B,C

	ORA	C

	RZ

	MOV	M,D	; ADDRESS IN H,L

	INX	H

	DCX	B

	JMP	ZF1

** ERROR MESSAGES

ERR1	CALL	TYPTX

	DB	CR,LF,'BIOS file name '

	DB	'missing.',CR,ELF

	JMP	0

ERR2	CALL	TYPTX

	DB	CR,LF,'Driver file name '

	DB	'missing.',CR,ELF

	JMP	0

ERR3	CALL	TYPTX

	DB	CR,LF,'BIOS file not found.',CR,ELF

	JMP	0

ERR4	CALL	TYPTX

	DB	CR,LF,'Driver file not found.',CR,ELF

	JMP	0

ERR5	CALL	TYPTX

	DB	CR,LF,'Incorrect file format',CR,ELF

	JMP	0

ERR6	CALL	TYPTX

	DB	CR,LF,'BIOS file write error',CR,ELF

	JMP	0

ERR7	CALL	TYPTX

	DB	CR,LF,'Error yyy',CR,ELF

	JMP	0

**

FCB2	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

FCB2CR	EQU	FCB2+32

FCB2RRN EQU	FCB2+33

BIOSORG DW	WORK	; START BIOS STORAGE

PTCHORG DW	0	; START PATCH STORAGE

ABLADD	DW	0	; ADDR OF BIOS LENGTH

ORG1	DW	WORK+100H ; ORIGIN OF BIOS CODE

LEN1	DW	0	; LENGTH OF BIOS CODE

LEN1A	DW	0	; LENGTH OF BIOS CODE + MOD 8

ORG2	DW	0	; START OF BIOS BIT MAP

ORG2A	DW	0	; NEW START BIT MAP

LEN2	DW	0	; LENGTH OF BIOS BIT MAP

LEN2A	DW	0	; LENGTH OF FILLED BIOS BIT MAP

ORG3	DW	0	; START OF PATCH CODE

ORG3A	DW	0	; NEW START OF PATCH CODE

LEN3	DW	0	; LENGTH OF PATCH CODE

LEN3A	DW	0	; ABOVE + MOD 8

ORG4	DW	0	; START OF PATCH BIT MAP

LEN4	DW	0	; LENGTH OF PATCH BIT MAP

ORG5	DW	0	; START OF BIOS BIT MAP TEMP AREA

LEN5	DW	0	; LENGTH TOTAL BIT MAP

ORG6	DW	0	; START OF PATCH BIT MAP TEMP AREA

SCADD	DW	0	; SIGNON CALL ADDRESS

SCALOC	DW	0	; LOCATION TO PUT ABOVE

PMADD	DW	0	; PMSG CALL ADDRESS

PMALOC	DW	0	; LOCATION TO PUT ABOVE

STADD	DW	0	; STATUS JUMP ADDRESS

DCADD	DW	0	; DRIVER CODE ADDRESS

NPGADD	DW	0	; OFFSET TO NUMBER OF PAGES

POINTER DW	0	; I/O OPERATIONS POINTER

ENDATA	DB	0	; END BLOCK OF NEW BIOS

STACK2	DW	0	; VERS .02 STACK SET LOCATION

STACK	EQU	1000H

WORK	EQU	2000H	; BIOS START ADDRESS

BCOFF	EQU	WORK+100H ; ORIGIN OF BIOS CODE



	END	BEGIN

